class MircWindows
{
private:
	HWND m_hwndMain;
	HWND m_hwndMdiChild;
	HWND m_hwndMaxChild;
	std::multimap< std::pair< LONG, LONG >, HWND > m_mmapChannels; // Sorted by special name, then Y position.

	const std::vector< std::wstring > * m_pvecTitlePrefixOrder;
	const std::vector< std::wstring > * m_pvecTitlePrefixIgnore;

public:
	MircWindows(HWND hwndMain, HWND hwndMdiChild);
	bool DoLayout(const std::vector< std::wstring > &vecTitlePrefixOrder, const std::vector< std::wstring > &vecTitlePrefixIgnore);

	HWND GetMdiChild() const { return m_hwndMdiChild; }

private:
	static BOOL CALLBACK EnumMdiChild(HWND hWnd, LPARAM lParam);
	static BOOL CALLBACK MircChannelDeMax(HWND hWnd, LPARAM lParam);
	static BOOL CALLBACK MircChannelMinOthers(HWND hWnd, LPARAM lParam);
	static BOOL CALLBACK MircChannelEnum(HWND hWnd, LPARAM lParam);

	bool CheckPrefixes(HWND hWnd, const std::vector< std::wstring > *pvecPrefixes, LONG *plSortWeight);
};
